"""An Opengear product type."""

from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.opengear import OpengearBlock, OpengearBlockInactive, OpengearBlockProvisioning


class OpengearInactive(SubscriptionModel, is_base=True):
    """An inactive Opengear."""

    opengear: OpengearBlockInactive


class OpengearProvisioning(OpengearInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    """An Opengear that is being provisioned."""

    opengear: OpengearBlockProvisioning


class Opengear(OpengearProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """An Opengear that is currently active."""

    opengear: OpengearBlock
